%%
%% appschedfileparser.tex
%% $Id: appschedfileparser.tex,v 1.10 2003-03-07 10:01:20 baurma Exp $
%%

\section{JNukeScheduleFileParser}

\label{app:schedfileparser}

The \texttt{JNukeScheduleFileParser} is an object that can read
a thread replay schedule given in a text file. The file must
be valid according to the specification given in Appendix
\ref{jreplay:cxfileformat}. See Figure~\ref{fig:schedfileparserusage} 
for an example how to use the parser.

\begin{figure}[ht!]
\footnotesize
\begin{center}
\begin{listing}{1}
JNukeObj *parser, *vec;

parser = JNukeScheduleFileParser_new (mem);
vec = JNukeScheduleFileParser_parse (parser, "filename.cx");
JNukeObj_delete (parser);
if (vec == NULL) {
    printf("Error: Unable to thread thread schedule from file\n");
}
\end{listing}
\normalsize
\end{center}
\caption{Example demonstrating the usage of the 
\texttt{JNukeScheduleFileParser} object}
\label{fig:schedfileparserusage}
\end{figure}

%% -----------------------------------------------------------------

\subsection{Constructor}

\code{
JNukeObj * \\
JNukeScheduleFileParser\_new( \\
\tab	JNukeMem * mem \\
)
}

\subsubsection{Description}

The constructor is called to obtain a new object instance.

\subsubsection{Parameters}

\begin{description}
\ttitem{mem}
	A memory manager object of type \texttt{JNukeMem}.
	It is being used to allocate memory for the new
	object instance.
\end{description}

\subsubsection{Return value}

	A pointer to a new instance of a \texttt{JNukeScheduleFileParser}
	object.
	
	
%% -----------------------------------------------------------------

\subsection{JNukeScheduleFileParser\_parse}

\code{
JNukeObj * \\
JNukeScheduleFileParser\_parse( \\
\tab	JNukeObj * this, \\
\tab	const char * filename \\
)
}

\subsubsection{Description}

Read a text file containing an execution trace into memory.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a schedule file parser object.
\ttitem{filename}
	Name of the file to be read. The file must exist
	and it may not be empty.
\end{description}

\subsubsection{Return value}

This function returns a vector of \texttt{JNukeThreadChange} objects. 
In case of an error, a \texttt{NULL} pointer is returned.

%% -----------------------------------------------------------------

\subsection{JNukeScheduleFileParser\_getClassNames}

\code{
JNukeObj * \\
JNukeScheduleFileParser\_getClassNames ( \\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Return a tagged set with the names of the classes being referenced in 
the thread schedule. Prior to calling this function, the method
\texttt{JNukeScheduleFileParser\_parse} has to be executed, otherwise 
the set will be empty.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a schedule file parser object.
\end{description}

\subsubsection{Return value}

A \texttt{JNukeTaggedSet} with the names of the classes referenced in
the thread schedule file.
